
/*
 * This file was generated by the SOM Compiler.
 * FileName: car.h.
 * Generated using:
 *     SOM Precompiler somipc: 2.2
 *     SOM Emitter emith: 2.7
 */

/*
 * 
 * 
 *    Module Name: CAR
 * 
 *    OS/2 Work Place Shell Sample Program - SOM 2.0 / IDL Version
 * 
 *    Copyright (C) 1992, 1993 IBM Corporation
 * 
 *        DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 *        sample code created by IBM Corporation. This sample code is not
 *        part of any standard or IBM product and is provided to you solely
 *        for  the purpose of assisting you in the development of your
 *        applications.  The code is provided "AS IS", without
 *        warranty of any kind.  IBM shall not be liable for any damages
 *        arising out of your use of the sample code, even if they have been
 *        advised of the possibility of such damages.
 * 
 */


#ifndef SOM_Car_h
#define SOM_Car_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef Car
#define Car SOMObject
#endif
#include <wpdataf.h>

/*
 * Start of user-defined types:
 */
#ifndef WPFolder
    #define WPFolder SOMObject
#endif /* WPFolder */

/*
 * End of user-defined types.
 */

/*
 * Passthru lines: File: "C.h", "after"
 */

   /*
    *   The following structures will be used to store window specific data
    *   and a pointer to the object that created the window/dialog.
    *
    *   They're allocated when the Client window is created.  This
    *   allows us to pass the *somSelf pointer and use it in our
    *   window and dialog procedures (the system only passes this
    *   pointer to methods).
    */
   typedef struct _WINDOWDATA
   {
      USHORT   cb;            /* size of this structure */
      Car     *somSelf;       /* pointer to this instance */
      USEITEM  UseItem;       /* global class usage information */
      VIEWITEM ViewItem;      /* global class view information */
      LONG     x;             /* x position of car in open view */
      LONG     y;             /* y position of car in open view */
      LONG     xDir;          /* x direction (CAR_LEFT or CAR_RIGHT) */
      LONG     yDir;          /* y direction (CAR_UP or CAR_DOWN) */
   } WINDOWDATA;
   typedef WINDOWDATA *PWINDOWDATA;

   /*
    *   Window data for the Dashboard dialog (settings page)
    */
   typedef struct _DASHDLGDATA
   {
      USHORT   cb;            /* size of this structure */
      Car    *somSelf;        /* pointer to this instance         */
      BOOL    PrevBrakes;     /* indicates if car is stopped      */
      ULONG   PrevSpeed;      /* Speed car moves across screen    */
   } DASHDLGDATA;
   typedef DASHDLGDATA *PDASHDLGDATA;

   /*
    *   Window data for the Horn dialog (settings page)
    */
   typedef struct _HORNDLGDATA
   {
      USHORT   cb;            /* size of this structure */
      Car    *somSelf;        /* pointer to this instance         */
      ULONG   PrevDuration;   /* Duration of the car's horn beep  */
      ULONG   PrevHighTone;   /* The high note of the car beep    */
      ULONG   PrevLowTone;    /* The low note of the car beep     */
   } HORNDLGDATA;
   typedef HORNDLGDATA *PHORNDLGDATA;

   /*
    *   These defines are used as directional multipliers against x,y position.
    */
   #define CAR_LEFT  -1
   #define CAR_RIGHT  1
   #define CAR_DOWN  -1
   #define CAR_UP     1

   #define ICON_WIDTH   32     /* pels */
   #define ICON_HEIGHT  32     /* pels */

   /*
    *   Private Debug helpers go here.  They can be enabled/disabled by
    *   defining DEBUG as a compiler directive.
    */
   #if defined(DEBUG)

      #define DebugBox(title, text) \ 
                                    \ 
                 WinMessageBox(     \ 
                    HWND_DESKTOP,   \ 
                    HWND_DESKTOP,   \ 
                    (PSZ) text,     \ 
                    (PSZ) title,    \ 
                    20,             \ 
                    MB_OK | MB_INFORMATION | MB_MOVEABLE)
   #else
      #define DebugBox(title, text)   /* do nothing if not debugging */
   #endif


#define Car_MajorVersion 1
#define Car_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define CarNewClass carc
#pragma linkage(carc, system)
#define CarClassData card
#define CarCClassData carx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */

/*
 * Include the meta class file
 */
#include <car.h>
/*--------------Migration------------*/
#define Car_classObj CarClassData.classObject
#define _Car Car_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK CarNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(CarNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct CarClassDataStructure {
	SOMAny *classObject;
	somMToken QueryBrakes;
	somMToken SetBrakes;
	somMToken QueryDuration;
	somMToken SetDuration;
	somMToken QueryHighTone;
	somMToken SetHighTone;
	somMToken QueryLowTone;
	somMToken SetLowTone;
	somMToken QuerySpeed;
	somMToken SetSpeed;
	somMToken BeepHorn;
	somMToken AddDashboardPage;
	somMToken AddHornBeepPage;
	somMToken TrapTest;
} CarClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct CarCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} CarCClassData;

/*
 * New and Renew macros for Car
 */
#define CarNew() \
	( CarClassData.classObject \
		? (_somNew(CarClassData.classObject)) \
		: ( CarNewClass(Car_MajorVersion, Car_MinorVersion), (_somNew(CarClassData.classObject)) ) )
#define CarRenew(buf) \
	( _somRenew(CarClassData.classObject, buf) )

/*
 * Override method: wpInitData
 */
#define Car_wpInitData(somSelf) \
	WPObject_wpInitData(somSelf)

/*
 * Override method: wpUnInitData
 */
#define Car_wpUnInitData(somSelf) \
	WPObject_wpUnInitData(somSelf)

/*
 * Override method: wpSaveState
 */
#define Car_wpSaveState(somSelf) \
	WPObject_wpSaveState(somSelf)

/*
 * Override method: wpRestoreState
 */
#define Car_wpRestoreState(somSelf,ulReserved) \
	WPObject_wpRestoreState(somSelf,ulReserved)

/*
 * Override method: wpAddSettingsPages
 */
#define Car_wpAddSettingsPages(somSelf,hwndNotebook) \
	WPObject_wpAddSettingsPages(somSelf,hwndNotebook)

/*
 * Override method: wpFilterPopupMenu
 */
#define Car_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,fMultiSelect) \
	WPObject_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,fMultiSelect)

/*
 * Override method: wpModifyPopupMenu
 */
#define Car_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition) \
	WPObject_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition)

/*
 * Override method: wpMenuItemSelected
 */
#define Car_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId) \
	WPObject_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId)

/*
 * Override method: wpMenuItemHelpSelected
 */
#define Car_wpMenuItemHelpSelected(somSelf,MenuId) \
	WPObject_wpMenuItemHelpSelected(somSelf,MenuId)

/*
 * Override method: wpQueryDetailsData
 */
#define Car_wpQueryDetailsData(somSelf,ppDetailsData,pcp) \
	WPObject_wpQueryDetailsData(somSelf,ppDetailsData,pcp)

/*
 * Override method: wpOpen
 */
#define Car_wpOpen(somSelf,hwndCnr,ulView,param) \
	WPObject_wpOpen(somSelf,hwndCnr,ulView,param)

/*
 * Override method: wpSetup
 */
#define Car_wpSetup(somSelf,pszSetupString) \
	WPObject_wpSetup(somSelf,pszSetupString)

/*
 * New Method: QueryBrakes
 */
typedef BOOL   SOMLINK somTP_Car_QueryBrakes(Car *somSelf);
#pragma linkage(somTP_Car_QueryBrakes, system)
typedef somTP_Car_QueryBrakes *somTD_Car_QueryBrakes;
#define somMD_Car_QueryBrakes "::Car::QueryBrakes"
#define Car_QueryBrakes(somSelf) \
    (SOM_Resolve(somSelf, Car, QueryBrakes) \
	(somSelf))
#ifndef SOMGD_QueryBrakes
    #if (defined(_QueryBrakes) || defined(__QueryBrakes))
        #undef _QueryBrakes
        #undef __QueryBrakes
        #define SOMGD_QueryBrakes 1
    #else
        #define _QueryBrakes Car_QueryBrakes
    #endif /* _QueryBrakes */
#endif /* SOMGD_QueryBrakes */

/*
 * New Method: SetBrakes
 */
typedef void   SOMLINK somTP_Car_SetBrakes(Car *somSelf,
		BOOL fBrake);
#pragma linkage(somTP_Car_SetBrakes, system)
typedef somTP_Car_SetBrakes *somTD_Car_SetBrakes;
#define somMD_Car_SetBrakes "::Car::SetBrakes"
#define Car_SetBrakes(somSelf,fBrake) \
    (SOM_Resolve(somSelf, Car, SetBrakes) \
	(somSelf,fBrake))
#ifndef SOMGD_SetBrakes
    #if (defined(_SetBrakes) || defined(__SetBrakes))
        #undef _SetBrakes
        #undef __SetBrakes
        #define SOMGD_SetBrakes 1
    #else
        #define _SetBrakes Car_SetBrakes
    #endif /* _SetBrakes */
#endif /* SOMGD_SetBrakes */

/*
 * New Method: QueryDuration
 */
typedef ULONG   SOMLINK somTP_Car_QueryDuration(Car *somSelf);
#pragma linkage(somTP_Car_QueryDuration, system)
typedef somTP_Car_QueryDuration *somTD_Car_QueryDuration;
#define somMD_Car_QueryDuration "::Car::QueryDuration"
#define Car_QueryDuration(somSelf) \
    (SOM_Resolve(somSelf, Car, QueryDuration) \
	(somSelf))
#ifndef SOMGD_QueryDuration
    #if (defined(_QueryDuration) || defined(__QueryDuration))
        #undef _QueryDuration
        #undef __QueryDuration
        #define SOMGD_QueryDuration 1
    #else
        #define _QueryDuration Car_QueryDuration
    #endif /* _QueryDuration */
#endif /* SOMGD_QueryDuration */

/*
 * New Method: SetDuration
 */
typedef void   SOMLINK somTP_Car_SetDuration(Car *somSelf,
		ULONG ulDuration);
#pragma linkage(somTP_Car_SetDuration, system)
typedef somTP_Car_SetDuration *somTD_Car_SetDuration;
#define somMD_Car_SetDuration "::Car::SetDuration"
#define Car_SetDuration(somSelf,ulDuration) \
    (SOM_Resolve(somSelf, Car, SetDuration) \
	(somSelf,ulDuration))
#ifndef SOMGD_SetDuration
    #if (defined(_SetDuration) || defined(__SetDuration))
        #undef _SetDuration
        #undef __SetDuration
        #define SOMGD_SetDuration 1
    #else
        #define _SetDuration Car_SetDuration
    #endif /* _SetDuration */
#endif /* SOMGD_SetDuration */

/*
 * New Method: QueryHighTone
 */
typedef ULONG   SOMLINK somTP_Car_QueryHighTone(Car *somSelf);
#pragma linkage(somTP_Car_QueryHighTone, system)
typedef somTP_Car_QueryHighTone *somTD_Car_QueryHighTone;
#define somMD_Car_QueryHighTone "::Car::QueryHighTone"
#define Car_QueryHighTone(somSelf) \
    (SOM_Resolve(somSelf, Car, QueryHighTone) \
	(somSelf))
#ifndef SOMGD_QueryHighTone
    #if (defined(_QueryHighTone) || defined(__QueryHighTone))
        #undef _QueryHighTone
        #undef __QueryHighTone
        #define SOMGD_QueryHighTone 1
    #else
        #define _QueryHighTone Car_QueryHighTone
    #endif /* _QueryHighTone */
#endif /* SOMGD_QueryHighTone */

/*
 * New Method: SetHighTone
 */
typedef void   SOMLINK somTP_Car_SetHighTone(Car *somSelf,
		ULONG ulTone);
#pragma linkage(somTP_Car_SetHighTone, system)
typedef somTP_Car_SetHighTone *somTD_Car_SetHighTone;
#define somMD_Car_SetHighTone "::Car::SetHighTone"
#define Car_SetHighTone(somSelf,ulTone) \
    (SOM_Resolve(somSelf, Car, SetHighTone) \
	(somSelf,ulTone))
#ifndef SOMGD_SetHighTone
    #if (defined(_SetHighTone) || defined(__SetHighTone))
        #undef _SetHighTone
        #undef __SetHighTone
        #define SOMGD_SetHighTone 1
    #else
        #define _SetHighTone Car_SetHighTone
    #endif /* _SetHighTone */
#endif /* SOMGD_SetHighTone */

/*
 * New Method: QueryLowTone
 */
typedef ULONG   SOMLINK somTP_Car_QueryLowTone(Car *somSelf);
#pragma linkage(somTP_Car_QueryLowTone, system)
typedef somTP_Car_QueryLowTone *somTD_Car_QueryLowTone;
#define somMD_Car_QueryLowTone "::Car::QueryLowTone"
#define Car_QueryLowTone(somSelf) \
    (SOM_Resolve(somSelf, Car, QueryLowTone) \
	(somSelf))
#ifndef SOMGD_QueryLowTone
    #if (defined(_QueryLowTone) || defined(__QueryLowTone))
        #undef _QueryLowTone
        #undef __QueryLowTone
        #define SOMGD_QueryLowTone 1
    #else
        #define _QueryLowTone Car_QueryLowTone
    #endif /* _QueryLowTone */
#endif /* SOMGD_QueryLowTone */

/*
 * New Method: SetLowTone
 */
typedef void   SOMLINK somTP_Car_SetLowTone(Car *somSelf,
		ULONG ulTone);
#pragma linkage(somTP_Car_SetLowTone, system)
typedef somTP_Car_SetLowTone *somTD_Car_SetLowTone;
#define somMD_Car_SetLowTone "::Car::SetLowTone"
#define Car_SetLowTone(somSelf,ulTone) \
    (SOM_Resolve(somSelf, Car, SetLowTone) \
	(somSelf,ulTone))
#ifndef SOMGD_SetLowTone
    #if (defined(_SetLowTone) || defined(__SetLowTone))
        #undef _SetLowTone
        #undef __SetLowTone
        #define SOMGD_SetLowTone 1
    #else
        #define _SetLowTone Car_SetLowTone
    #endif /* _SetLowTone */
#endif /* SOMGD_SetLowTone */

/*
 * New Method: QuerySpeed
 */
typedef ULONG   SOMLINK somTP_Car_QuerySpeed(Car *somSelf);
#pragma linkage(somTP_Car_QuerySpeed, system)
typedef somTP_Car_QuerySpeed *somTD_Car_QuerySpeed;
#define somMD_Car_QuerySpeed "::Car::QuerySpeed"
#define Car_QuerySpeed(somSelf) \
    (SOM_Resolve(somSelf, Car, QuerySpeed) \
	(somSelf))
#ifndef SOMGD_QuerySpeed
    #if (defined(_QuerySpeed) || defined(__QuerySpeed))
        #undef _QuerySpeed
        #undef __QuerySpeed
        #define SOMGD_QuerySpeed 1
    #else
        #define _QuerySpeed Car_QuerySpeed
    #endif /* _QuerySpeed */
#endif /* SOMGD_QuerySpeed */

/*
 * New Method: SetSpeed
 */
typedef void   SOMLINK somTP_Car_SetSpeed(Car *somSelf,
		ULONG ulSpeed);
#pragma linkage(somTP_Car_SetSpeed, system)
typedef somTP_Car_SetSpeed *somTD_Car_SetSpeed;
#define somMD_Car_SetSpeed "::Car::SetSpeed"
#define Car_SetSpeed(somSelf,ulSpeed) \
    (SOM_Resolve(somSelf, Car, SetSpeed) \
	(somSelf,ulSpeed))
#ifndef SOMGD_SetSpeed
    #if (defined(_SetSpeed) || defined(__SetSpeed))
        #undef _SetSpeed
        #undef __SetSpeed
        #define SOMGD_SetSpeed 1
    #else
        #define _SetSpeed Car_SetSpeed
    #endif /* _SetSpeed */
#endif /* SOMGD_SetSpeed */

/*
 * New Method: BeepHorn
 */
typedef BOOL   SOMLINK somTP_Car_BeepHorn(Car *somSelf);
#pragma linkage(somTP_Car_BeepHorn, system)
typedef somTP_Car_BeepHorn *somTD_Car_BeepHorn;
#define somMD_Car_BeepHorn "::Car::BeepHorn"
#define Car_BeepHorn(somSelf) \
    (SOM_Resolve(somSelf, Car, BeepHorn) \
	(somSelf))
#ifndef SOMGD_BeepHorn
    #if (defined(_BeepHorn) || defined(__BeepHorn))
        #undef _BeepHorn
        #undef __BeepHorn
        #define SOMGD_BeepHorn 1
    #else
        #define _BeepHorn Car_BeepHorn
    #endif /* _BeepHorn */
#endif /* SOMGD_BeepHorn */

/*
 * New Method: AddDashboardPage
 */
typedef ULONG   SOMLINK somTP_Car_AddDashboardPage(Car *somSelf,
		HWND hwndNotebook);
#pragma linkage(somTP_Car_AddDashboardPage, system)
typedef somTP_Car_AddDashboardPage *somTD_Car_AddDashboardPage;
#define somMD_Car_AddDashboardPage "::Car::AddDashboardPage"
#define Car_AddDashboardPage(somSelf,hwndNotebook) \
    (SOM_Resolve(somSelf, Car, AddDashboardPage) \
	(somSelf,hwndNotebook))
#ifndef SOMGD_AddDashboardPage
    #if (defined(_AddDashboardPage) || defined(__AddDashboardPage))
        #undef _AddDashboardPage
        #undef __AddDashboardPage
        #define SOMGD_AddDashboardPage 1
    #else
        #define _AddDashboardPage Car_AddDashboardPage
    #endif /* _AddDashboardPage */
#endif /* SOMGD_AddDashboardPage */

/*
 * New Method: AddHornBeepPage
 */
typedef ULONG   SOMLINK somTP_Car_AddHornBeepPage(Car *somSelf,
		HWND hwndNotebook);
#pragma linkage(somTP_Car_AddHornBeepPage, system)
typedef somTP_Car_AddHornBeepPage *somTD_Car_AddHornBeepPage;
#define somMD_Car_AddHornBeepPage "::Car::AddHornBeepPage"
#define Car_AddHornBeepPage(somSelf,hwndNotebook) \
    (SOM_Resolve(somSelf, Car, AddHornBeepPage) \
	(somSelf,hwndNotebook))
#ifndef SOMGD_AddHornBeepPage
    #if (defined(_AddHornBeepPage) || defined(__AddHornBeepPage))
        #undef _AddHornBeepPage
        #undef __AddHornBeepPage
        #define SOMGD_AddHornBeepPage 1
    #else
        #define _AddHornBeepPage Car_AddHornBeepPage
    #endif /* _AddHornBeepPage */
#endif /* SOMGD_AddHornBeepPage */

/*
 * New Method: TrapTest
 */
typedef void   SOMLINK somTP_Car_TrapTest(Car *somSelf);
#pragma linkage(somTP_Car_TrapTest, system)
typedef somTP_Car_TrapTest *somTD_Car_TrapTest;
#define somMD_Car_TrapTest "::Car::TrapTest"
#define Car_TrapTest(somSelf) \
    (SOM_Resolve(somSelf, Car, TrapTest) \
	(somSelf))
#ifndef SOMGD_TrapTest
    #if (defined(_TrapTest) || defined(__TrapTest))
        #undef _TrapTest
        #undef __TrapTest
        #define SOMGD_TrapTest 1
    #else
        #define _TrapTest Car_TrapTest
    #endif /* _TrapTest */
#endif /* SOMGD_TrapTest */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define Car_wpAddFileTypePage WPDataFile_wpAddFileTypePage
#define Car_wpPrintMetaFile WPDataFile_wpPrintMetaFile
#define Car_wpPrintPifFile WPDataFile_wpPrintPifFile
#define Car_wpPrintPrinterSpecificFile WPDataFile_wpPrintPrinterSpecificFile
#define Car_wpPrintUnknownFile WPDataFile_wpPrintUnknownFile
#define Car_wpQueryAssociatedProgram WPDataFile_wpQueryAssociatedProgram
#define Car_wpSetAssociatedFileIcon WPDataFile_wpSetAssociatedFileIcon
#define Car_wpDragOver WPObject_wpDragOver
#define Car_wpSetDefaultView WPObject_wpSetDefaultView
#define Car_wpSetRealName WPFileSystem_wpSetRealName
#define Car_wpSetType WPFileSystem_wpSetType
#define Car_wpAddObjectWindowPage WPObject_wpAddObjectWindowPage
#define Car_wpPrintObject WPObject_wpPrintObject
#define Car_wpQueryDefaultHelp WPObject_wpQueryDefaultHelp
#define Car_wpFormatDragItem WPObject_wpFormatDragItem
#define Car_wpConfirmRenameFileWithExt WPFileSystem_wpConfirmRenameFileWithExt
#define Car_wpSetRealName WPFileSystem_wpSetRealName
#define Car_wpSetType WPFileSystem_wpSetType
#define Car_wpQueryType WPFileSystem_wpQueryType
#define Car_wpSetAttr WPFileSystem_wpSetAttr
#define Car_wpQueryAttr WPFileSystem_wpQueryAttr
#define Car_wpAddFile1Page WPFileSystem_wpAddFile1Page
#define Car_wpAddFile2Page WPFileSystem_wpAddFile2Page
#define Car_wpAddFile3Page WPFileSystem_wpAddFile3Page
#define Car_wpAddFileMenuPage WPFileSystem_wpAddFileMenuPage
#define Car_wpQueryCreation WPFileSystem_wpQueryCreation
#define Car_wpQueryLastAccess WPFileSystem_wpQueryLastAccess
#define Car_wpQueryLastWrite WPFileSystem_wpQueryLastWrite
#define Car_wpQueryFileSize WPFileSystem_wpQueryFileSize
#define Car_wpQueryEASize WPFileSystem_wpQueryEASize
#define Car_wpSetDateInfo WPFileSystem_wpSetDateInfo
#define Car_wpSetFileSizeInfo WPFileSystem_wpSetFileSizeInfo
#define Car_wpRefresh WPFileSystem_wpRefresh
#define Car_wpQueryRefreshFlags WPFileSystem_wpQueryRefreshFlags
#define Car_wpSetRefreshFlags WPFileSystem_wpSetRefreshFlags
#define Car_wpPrintPlainTextFile WPFileSystem_wpPrintPlainTextFile
#define Car_wpSetTitleAndRenameFile WPFileSystem_wpSetTitleAndRenameFile
#define Car_wpConfirmRenameFileWithExt WPFileSystem_wpConfirmRenameFileWithExt
#define Car_wpVerifyUpdateAccess WPFileSystem_wpVerifyUpdateAccess
#define Car_wpAddUserItemsToPopupMenu WPFileSystem_wpAddUserItemsToPopupMenu
#define Car_wpQueryRealName WPFileSystem_wpQueryRealName
#define Car_wpQueryHandle WPObject_wpQueryHandle
#define Car_wpSaveImmediate WPObject_wpSaveImmediate
#define Car_wpSetTitle WPObject_wpSetTitle
#define Car_wpViewObject WPObject_wpViewObject
#define Car_wpSwitchTo WPObject_wpSwitchTo
#define Car_wpCopyObject WPObject_wpCopyObject
#define Car_wpCreateFromTemplate WPObject_wpCreateFromTemplate
#define Car_wpMoveObject WPObject_wpMoveObject
#define Car_wpQueryIconData WPObject_wpQueryIconData
#define Car_wpSetIconData WPObject_wpSetIconData
#define Car_wpDraggedOverObject WPObject_wpDraggedOverObject
#define Car_wpDroppedOnObject WPObject_wpDroppedOnObject
#define Car_wpFormatDragItem WPObject_wpFormatDragItem
#define Car_wpQueryNameClashOptions WPObject_wpQueryNameClashOptions
#define Car_wpAppendObject WPObject_wpAppendObject
#define Car_wpReplaceObject WPObject_wpReplaceObject
#define Car_wpQueryStyle WPObject_wpQueryStyle
#define Car_wpSetStyle WPObject_wpSetStyle
#define Car_wpDoesObjectMatch WPObject_wpDoesObjectMatch
#define Car_wpAddObjectGeneralPage WPObject_wpAddObjectGeneralPage
#define Car_wpAddObjectWindowPage WPObject_wpAddObjectWindowPage
#define Car_wpAddToObjUseList WPObject_wpAddToObjUseList
#define Car_wpAllocMem WPObject_wpAllocMem
#define Car_wpAppendObject WPObject_wpAppendObject
#define Car_wpAssertObjectMutexSem WPObject_wpAssertObjectMutexSem
#define Car_wpClose WPObject_wpClose
#define Car_wpCnrInsertObject WPObject_wpCnrInsertObject
#define Car_wpCnrRemoveObject WPObject_wpCnrRemoveObject
#define Car_wpCnrSetEmphasis WPObject_wpCnrSetEmphasis
#define Car_wpConfirmDelete WPObject_wpConfirmDelete
#define Car_wpConfirmObjectTitle WPObject_wpConfirmObjectTitle
#define Car_wpCopiedFromTemplate WPObject_wpCopiedFromTemplate
#define Car_wpCopyObject WPObject_wpCopyObject
#define Car_wpCreateAnother WPObject_wpCreateAnother
#define Car_wpCreateFromTemplate WPObject_wpCreateFromTemplate
#define Car_wpCreateShadowObject WPObject_wpCreateShadowObject
#define Car_wpDelete WPObject_wpDelete
#define Car_wpDeleteFromObjUseList WPObject_wpDeleteFromObjUseList
#define Car_wpDisplayHelp WPObject_wpDisplayHelp
#define Car_wpDoesObjectMatch WPObject_wpDoesObjectMatch
#define Car_wpDraggedOverObject WPObject_wpDraggedOverObject
#define Car_wpDragOver WPObject_wpDragOver
#define Car_wpDrop WPObject_wpDrop
#define Car_wpDroppedOnObject WPObject_wpDroppedOnObject
#define Car_wpEndConversation WPObject_wpEndConversation
#define Car_wpFindUseItem WPObject_wpFindUseItem
#define Car_wpFormatDragItem WPObject_wpFormatDragItem
#define Car_wpFree WPObject_wpFree
#define Car_wpFreeMem WPObject_wpFreeMem
#define Car_wpHide WPObject_wpHide
#define Car_wpInsertPopupMenuItems WPObject_wpInsertPopupMenuItems
#define Car_wpInsertSettingsPage WPObject_wpInsertSettingsPage
#define Car_wpMoveObject WPObject_wpMoveObject
#define Car_wpPrintObject WPObject_wpPrintObject
#define Car_wpQueryConcurrentView WPObject_wpQueryConcurrentView
#define Car_wpQueryButtonAppearance WPObject_wpQueryButtonAppearance
#define Car_wpQueryConfirmations WPObject_wpQueryConfirmations
#define Car_wpQueryDefaultHelp WPObject_wpQueryDefaultHelp
#define Car_wpQueryDefaultView WPObject_wpQueryDefaultView
#define Car_wpQueryError WPObject_wpQueryError
#define Car_wpQueryIcon WPObject_wpQueryIcon
#define Car_wpQueryIconData WPObject_wpQueryIconData
#define Car_wpQueryMinWindow WPObject_wpQueryMinWindow
#define Car_wpQueryNameClashOptions WPObject_wpQueryNameClashOptions
#define Car_wpQueryStyle WPObject_wpQueryStyle
#define Car_wpSetTaskRec WPObject_wpSetTaskRec
#define Car_wpFindTaskRec WPObject_wpFindTaskRec
#define Car_wpQueryTitle WPObject_wpQueryTitle
#define Car_wpRegisterView WPObject_wpRegisterView
#define Car_wpReleaseObjectMutexSem WPObject_wpReleaseObjectMutexSem
#define Car_wpRender WPObject_wpRender
#define Car_wpRenderComplete WPObject_wpRenderComplete
#define Car_wpReplaceObject WPObject_wpReplaceObject
#define Car_wpRequestObjectMutexSem WPObject_wpRequestObjectMutexSem
#define Car_wpRestore WPObject_wpRestore
#define Car_wpRestoreData WPObject_wpRestoreData
#define Car_wpRestoreLong WPObject_wpRestoreLong
#define Car_wpRestoreString WPObject_wpRestoreString
#define Car_wpSaveData WPObject_wpSaveData
#define Car_wpSaveImmediate WPObject_wpSaveImmediate
#define Car_wpSaveDeferred WPObject_wpSaveDeferred
#define Car_wpSaveLong WPObject_wpSaveLong
#define Car_wpSaveString WPObject_wpSaveString
#define Car_wpScanSetupString WPObject_wpScanSetupString
#define Car_wpSetConcurrentView WPObject_wpSetConcurrentView
#define Car_wpSetButtonAppearance WPObject_wpSetButtonAppearance
#define Car_wpSetDefaultHelp WPObject_wpSetDefaultHelp
#define Car_wpSetDefaultView WPObject_wpSetDefaultView
#define Car_wpSetError WPObject_wpSetError
#define Car_wpSetIcon WPObject_wpSetIcon
#define Car_wpSetIconData WPObject_wpSetIconData
#define Car_wpSetMinWindow WPObject_wpSetMinWindow
#define Car_wpSetStyle WPObject_wpSetStyle
#define Car_wpModifyStyle WPObject_wpModifyStyle
#define Car_wpSetTitle WPObject_wpSetTitle
#define Car_wpSwitchTo WPObject_wpSwitchTo
#define Car_wpViewObject WPObject_wpViewObject
#define Car_wpQueryTrueStyle WPObject_wpQueryTrueStyle
#define Car_wpQueryHandle WPObject_wpQueryHandle
#define Car_wpUnlockObject WPObject_wpUnlockObject
#define Car_somInit SOMObject_somInit
#define Car_somUninit SOMObject_somUninit
#define Car_somFree SOMObject_somFree
#define Car_somDefaultInit SOMObject_somDefaultInit
#define Car_somDestruct SOMObject_somDestruct
#define Car_somInit SOMObject_somInit
#define Car_somUninit SOMObject_somUninit
#define Car_somGetClass SOMObject_somGetClass
#define Car_somGetClassName SOMObject_somGetClassName
#define Car_somGetSize SOMObject_somGetSize
#define Car_somIsA SOMObject_somIsA
#define Car_somIsInstanceOf SOMObject_somIsInstanceOf
#define Car_somRespondsTo SOMObject_somRespondsTo
#define Car_somComputeForwardVisitMask SOMObject_somComputeForwardVisitMask
#define Car_somComputeReverseVisitMask SOMObject_somComputeReverseVisitMask
#define Car_somDispatchV SOMObject_somDispatchV
#define Car_somDispatchL SOMObject_somDispatchL
#define Car_somDispatchA SOMObject_somDispatchA
#define Car_somDispatchD SOMObject_somDispatchD
#define Car_somDispatch SOMObject_somDispatch
#define Car_somClassDispatch SOMObject_somClassDispatch
#define Car_somCastObj SOMObject_somCastObj
#define Car_somResetObj SOMObject_somResetObj
#define Car_somPrintSelf SOMObject_somPrintSelf
#define Car_somDumpSelf SOMObject_somDumpSelf
#define Car_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_Car_h */

#ifndef SOM_M_Car_h
#define SOM_M_Car_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef M_Car
#define M_Car SOMObject
#endif
#include <wpdataf.h>

/*
 * Start of user-defined types:
 */
#ifndef WPFolder
    #define WPFolder SOMObject
#endif /* WPFolder */

/*
 * End of user-defined types.
 */

#define M_Car_MajorVersion 1
#define M_Car_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_CarNewClass carc
#pragma linkage(carc, system)
#define M_CarClassData card
#define M_CarCClassData carx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_Car_classObj M_CarClassData.classObject
#define _M_Car M_Car_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK M_CarNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(M_CarNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_CarClassDataStructure {
	SOMAny *classObject;
	somMToken clsQueryModuleHandle;
} M_CarClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_CarCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} M_CarCClassData;

/*
 * New and Renew macros for M_Car
 */
#define M_CarNew() \
	( M_CarClassData.classObject \
		? (_somNew(M_CarClassData.classObject)) \
		: ( M_CarNewClass(M_Car_MajorVersion, M_Car_MinorVersion), (_somNew(M_CarClassData.classObject)) ) )
#define M_CarRenew(buf) \
	( _somRenew(M_CarClassData.classObject, buf) )

/*
 * Override method: wpclsInitData
 */
#define M_Car_wpclsInitData(somSelf) \
	M_WPObject_wpclsInitData(somSelf)

/*
 * Override method: wpclsUnInitData
 */
#define M_Car_wpclsUnInitData(somSelf) \
	M_WPObject_wpclsUnInitData(somSelf)

/*
 * Override method: wpclsQueryTitle
 */
#define M_Car_wpclsQueryTitle(somSelf) \
	M_WPObject_wpclsQueryTitle(somSelf)

/*
 * Override method: wpclsQueryIconData
 */
#define M_Car_wpclsQueryIconData(somSelf,pIconInfo) \
	M_WPObject_wpclsQueryIconData(somSelf,pIconInfo)

/*
 * Override method: wpclsQueryDefaultHelp
 */
#define M_Car_wpclsQueryDefaultHelp(somSelf,pHelpPanelId,pszHelpLibrary) \
	M_WPObject_wpclsQueryDefaultHelp(somSelf,pHelpPanelId,pszHelpLibrary)

/*
 * Override method: wpclsQueryDefaultView
 */
#define M_Car_wpclsQueryDefaultView(somSelf) \
	M_WPObject_wpclsQueryDefaultView(somSelf)

/*
 * Override method: wpclsQueryDetailsInfo
 */
#define M_Car_wpclsQueryDetailsInfo(somSelf,ppClassFieldInfo,pSize) \
	M_WPObject_wpclsQueryDetailsInfo(somSelf,ppClassFieldInfo,pSize)

/*
 * Override method: wpclsQueryDetails
 */
#define M_Car_wpclsQueryDetails(somSelf) \
	M_WPObject_wpclsQueryDetails(somSelf)

/*
 * Override method: wpclsQueryInstanceFilter
 */
#define M_Car_wpclsQueryInstanceFilter(somSelf) \
	M_WPFileSystem_wpclsQueryInstanceFilter(somSelf)

/*
 * Override method: wpclsQueryStyle
 */
#define M_Car_wpclsQueryStyle(somSelf) \
	M_WPObject_wpclsQueryStyle(somSelf)

/*
 * New Method: clsQueryModuleHandle
 */
typedef HMODULE   SOMLINK somTP_M_Car_clsQueryModuleHandle(M_Car *somSelf);
#pragma linkage(somTP_M_Car_clsQueryModuleHandle, system)
typedef somTP_M_Car_clsQueryModuleHandle *somTD_M_Car_clsQueryModuleHandle;
#define somMD_M_Car_clsQueryModuleHandle "::M_Car::clsQueryModuleHandle"
#define M_Car_clsQueryModuleHandle(somSelf) \
    (SOM_Resolve(somSelf, M_Car, clsQueryModuleHandle) \
	(somSelf))
#ifndef SOMGD_clsQueryModuleHandle
    #if (defined(_clsQueryModuleHandle) || defined(__clsQueryModuleHandle))
        #undef _clsQueryModuleHandle
        #undef __clsQueryModuleHandle
        #define SOMGD_clsQueryModuleHandle 1
    #else
        #define _clsQueryModuleHandle M_Car_clsQueryModuleHandle
    #endif /* _clsQueryModuleHandle */
#endif /* SOMGD_clsQueryModuleHandle */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define M_Car_wpclsQueryObjectFromPath M_WPFileSystem_wpclsQueryObjectFromPath
#define M_Car_wpclsQueryInstanceType M_WPFileSystem_wpclsQueryInstanceType
#define M_Car_wpclsQuerySearchInfo M_WPObject_wpclsQuerySearchInfo
#define M_Car_wpclsQueryExtendedCriteria M_WPObject_wpclsQueryExtendedCriteria
#define M_Car_wpclsCreateDefaultTemplates M_WPObject_wpclsCreateDefaultTemplates
#define M_Car_wpclsMakeAwake M_WPObject_wpclsMakeAwake
#define M_Car_wpclsNew M_WPObject_wpclsNew
#define M_Car_wpclsQueryExtendedCriteria M_WPObject_wpclsQueryExtendedCriteria
#define M_Car_wpclsQueryFolder M_WPObject_wpclsQueryFolder
#define M_Car_wpclsQueryIcon M_WPObject_wpclsQueryIcon
#define M_Car_wpclsQuerySearchInfo M_WPObject_wpclsQuerySearchInfo
#define M_Car_wpclsFindObjectFirst M_WPObject_wpclsFindObjectFirst
#define M_Car_wpclsFindObjectNext M_WPObject_wpclsFindObjectNext
#define M_Car_wpclsFindObjectEnd M_WPObject_wpclsFindObjectEnd
#define M_Car_wpclsSetError M_WPObject_wpclsSetError
#define M_Car_wpclsQueryError M_WPObject_wpclsQueryError
#define M_Car_wpclsQuerySettingsPageSize M_WPObject_wpclsQuerySettingsPageSize
#define M_Car_wpclsQueryObject M_WPObject_wpclsQueryObject
#define M_Car_wpclsQueryButtonAppearance M_WPObject_wpclsQueryButtonAppearance
#define M_Car_somUninit SOMObject_somUninit
#define M_Car_somInitClass SOMClass_somInitClass
#define M_Car_somNew SOMClass_somNew
#define M_Car_somRenew SOMClass_somRenew
#define M_Car__get_somDirectInitClasses SOMClass__get_somDirectInitClasses
#define M_Car__set_somDirectInitClasses SOMClass__set_somDirectInitClasses
#define M_Car_somGetInstanceInitMask SOMClass_somGetInstanceInitMask
#define M_Car_somGetInstanceDestructionMask SOMClass_somGetInstanceDestructionMask
#define M_Car_somGetInitMaskOffset SOMClass_somGetInitMaskOffset
#define M_Car_somGetDestructionMaskOffset SOMClass_somGetDestructionMaskOffset
#define M_Car_somShouldCallInit SOMClass_somShouldCallInit
#define M_Car_somAllocate SOMClass_somAllocate
#define M_Car_somDeallocate SOMClass_somDeallocate
#define M_Car_somNew SOMClass_somNew
#define M_Car_somNewNoInit SOMClass_somNewNoInit
#define M_Car_somRenew SOMClass_somRenew
#define M_Car_somRenewNoInit SOMClass_somRenewNoInit
#define M_Car_somRenewNoZero SOMClass_somRenewNoZero
#define M_Car_somRenewNoInitNoZero SOMClass_somRenewNoInitNoZero
#define M_Car_somInitClass SOMClass_somInitClass
#define M_Car_somInitMIClass SOMClass_somInitMIClass
#define M_Car_somAddStaticMethod SOMClass_somAddStaticMethod
#define M_Car_somAddMethod SOMClass_somAddMethod
#define M_Car_somRegLPMToken SOMClass_somRegLPMToken
#define M_Car_somAddDynamicMethod SOMClass_somAddDynamicMethod
#define M_Car_somClassReady SOMClass_somClassReady
#define M_Car_somOverrideSMethod SOMClass_somOverrideSMethod
#define M_Car_somGetApplyStub SOMClass_somGetApplyStub
#define M_Car_somGetClassData SOMClass_somGetClassData
#define M_Car_somSetClassData SOMClass_somSetClassData
#define M_Car_somGetClassMtab SOMClass_somGetClassMtab
#define M_Car_somGetInstanceOffset SOMClass_somGetInstanceOffset
#define M_Car_somGetInstancePartSize SOMClass_somGetInstancePartSize
#define M_Car_somGetInstanceSize SOMClass_somGetInstanceSize
#define M_Car_somGetDataAlignment SOMClass_somGetDataAlignment
#define M_Car_somGetInstanceToken SOMClass_somGetInstanceToken
#define M_Car_somGetMemberToken SOMClass_somGetMemberToken
#define M_Car_somGetMethodData SOMClass_somGetMethodData
#define M_Car_somGetRdStub SOMClass_somGetRdStub
#define M_Car_somGetMethodDescriptor SOMClass_somGetMethodDescriptor
#define M_Car_somGetMethodIndex SOMClass_somGetMethodIndex
#define M_Car_somGetMethodOffset SOMClass_somGetMethodOffset
#define M_Car_somGetMethodToken SOMClass_somGetMethodToken
#define M_Car_somGetName SOMClass_somGetName
#define M_Car_somGetNthMethodData SOMClass_somGetNthMethodData
#define M_Car_somGetNthMethodInfo SOMClass_somGetNthMethodInfo
#define M_Car_somGetNumMethods SOMClass_somGetNumMethods
#define M_Car_somGetNumStaticMethods SOMClass_somGetNumStaticMethods
#define M_Car_somGetParent SOMClass_somGetParent
#define M_Car_somGetParents SOMClass_somGetParents
#define M_Car_somGetPClsMtab SOMClass_somGetPClsMtab
#define M_Car_somGetPClsMtabs SOMClass_somGetPClsMtabs
#define M_Car_somGetVersionNumbers SOMClass_somGetVersionNumbers
#define M_Car_somSetMethodDescriptor SOMClass_somSetMethodDescriptor
#define M_Car_somCheckVersion SOMClass_somCheckVersion
#define M_Car_somDescendedFrom SOMClass_somDescendedFrom
#define M_Car_somSupportsMethod SOMClass_somSupportsMethod
#define M_Car__get_somReleaseOrder SOMClass__get_somReleaseOrder
#define M_Car__set_somReleaseOrder SOMClass__set_somReleaseOrder
#define M_Car_somGetClassDataEntry SOMClass_somGetClassDataEntry
#define M_Car_somSetClassDataEntry SOMClass_somSetClassDataEntry
#define M_Car_somDefinedMethod SOMClass_somDefinedMethod
#define M_Car_somCastObjCls SOMClass_somCastObjCls
#define M_Car_somResetObjCls SOMClass_somResetObjCls
#define M_Car__get_trueClass SOMClass__get_trueClass
#define M_Car__get_castedClass SOMClass__get_castedClass
#define M_Car_somCloneClass SOMClass_somCloneClass
#define M_Car_somFindMethod SOMClass_somFindMethod
#define M_Car_somFindMethodOk SOMClass_somFindMethodOk
#define M_Car_somFindSMethod SOMClass_somFindSMethod
#define M_Car_somFindSMethodOk SOMClass_somFindSMethodOk
#define M_Car_somLookupMethod SOMClass_somLookupMethod
#define M_Car_somOverrideMtab SOMClass_somOverrideMtab
#define M_Car__get_somInstanceDataOffsets SOMClass__get_somInstanceDataOffsets
#define M_Car__get_somMethodOffsets SOMClass__get_somMethodOffsets
#define M_Car_somInit SOMObject_somInit
#define M_Car_somUninit SOMObject_somUninit
#define M_Car_somDumpSelfInt SOMObject_somDumpSelfInt
#define M_Car_somPrintSelf SOMObject_somPrintSelf
#define M_Car_somFree SOMObject_somFree
#define M_Car_somDefaultInit SOMObject_somDefaultInit
#define M_Car_somDestruct SOMObject_somDestruct
#define M_Car_somInit SOMObject_somInit
#define M_Car_somUninit SOMObject_somUninit
#define M_Car_somGetClass SOMObject_somGetClass
#define M_Car_somGetClassName SOMObject_somGetClassName
#define M_Car_somGetSize SOMObject_somGetSize
#define M_Car_somIsA SOMObject_somIsA
#define M_Car_somIsInstanceOf SOMObject_somIsInstanceOf
#define M_Car_somRespondsTo SOMObject_somRespondsTo
#define M_Car_somComputeForwardVisitMask SOMObject_somComputeForwardVisitMask
#define M_Car_somComputeReverseVisitMask SOMObject_somComputeReverseVisitMask
#define M_Car_somDispatchV SOMObject_somDispatchV
#define M_Car_somDispatchL SOMObject_somDispatchL
#define M_Car_somDispatchA SOMObject_somDispatchA
#define M_Car_somDispatchD SOMObject_somDispatchD
#define M_Car_somDispatch SOMObject_somDispatch
#define M_Car_somClassDispatch SOMObject_somClassDispatch
#define M_Car_somCastObj SOMObject_somCastObj
#define M_Car_somResetObj SOMObject_somResetObj
#define M_Car_somPrintSelf SOMObject_somPrintSelf
#define M_Car_somDumpSelf SOMObject_somDumpSelf
#define M_Car_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_M_Car_h */
